---
title: X-Forwarded-For
slug: Web/HTTP/Headers/X-Forwarded-For
tags:
  - HTTP
  - HTTP Header
  - Non-standard
  - Reference
  - Request header
  - header
---
<div>{{HTTPSidebar}}</div>

<p>The <strong><code>X-Forwarded-For</code></strong> (XFF) header is a de-facto standard header for identifying the originating IP address of a client connecting to a web server through an HTTP proxy or a load balancer. When traffic is intercepted between clients and servers, server access logs contain the IP address of the proxy or load balancer only. To see the original IP address of the client, the <code>X-Forwarded-For</code> request header is used.</p>

<p>This header is used for debugging, statistics, and generating location-dependent content and by design it exposes privacy sensitive information, such as the IP address of the client. Therefore the user's privacy must be kept in mind when deploying this header.</p>

<p>A standardized version of this header is the HTTP {{HTTPHeader("Forwarded")}} header.</p>

<p><code>X-Forwarded-For</code> is also an email-header indicating that an email-message was forwarded from another account.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Request header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">X-Forwarded-For: &lt;client&gt;, &lt;proxy1&gt;, &lt;proxy2&gt;
</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt>&lt;client&gt;</dt>
 <dd>The client IP address</dd>
 <dt>&lt;proxy1&gt;, &lt;proxy2&gt;</dt>
 <dd>If a request goes through multiple proxies, the IP addresses of each successive proxy is listed. This means, the right-most IP address is the IP address of the most recent proxy and the left-most IP address is the IP address of the originating client.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre>X-Forwarded-For: 2001:db8:85a3:8d3:1319:8a2e:370:7348

X-Forwarded-For: 203.0.113.195

X-Forwarded-For: 203.0.113.195, 70.41.3.18, 150.172.238.178
</pre>

<p>Other non-standard forms:</p>

<pre># Used for some Google services
X-ProxyUser-Ip: 203.0.113.19</pre>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any current specification. The standardized version of this header is {{HTTPHeader("Forwarded")}}.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.X-Forwarded-For")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Forwarded")}}</li>
 <li>{{HTTPHeader("X-Forwarded-Host")}}</li>
 <li>{{HTTPHeader("X-Forwarded-Proto")}}</li>
 <li>{{HTTPHeader("Via")}}</li>
</ul>
